(function () {
    var app = angular.module('messages', ['restangular', 'templates']);

    app.controller('MessagesController', function($scope, Restangular){
        $scope.baseMessages = Restangular.all('messages');

        $scope.baseMessages.getList().then(function(messages){
            $scope.messages = messages;
        });
    });

    app.directive('messageForm', function(){
        return {
            restrict: "E",
            templateUrl: 'message-form.html'
        }
    });

    app.controller('MessageController', function($scope, $timeout){
        this.delete = function(message){
            message.remove();
        };

        this.create = function(message){
            $scope.baseMesssages.post(message);
        };

        var timeout = null;
        var debounceUpdate = function(new_message, old_message){
            if(new_message == old_message){
                return;
            }
            if(timeout) {
                $timeout.cancel(timeout);
            }
            timeout = $timeout(new_message.save, 1000);
        };
        $scope.$watchCollection('message', debounceUpdate);
    });
})();
